<?php
error_reporting(E_ALL ^ E_NOTICE); // Report all errors except E_NOTICE warnings
ini_set('display_errors', 1); // turn error reporting on
//ini_set('log_errors', 1); // log errors
//ini_set('error_log', dirname(__FILE__) . '/error_log.txt'); // where to log errors
/*
Weather Display Conditions Messenger PHP Script by Mike Challis
More Info        - www.642weather.com/weather/scripts-wd-conditions-messenger.php
Download         - www.642weather.com/weather/scripts/wd-conditions-messenger.zip
Live Demo        - www.642weather.com/weather/wd-conditions-messenger.php
Free PHP Scripts - www.642weather.com/weather/scripts.php
Contact Mike     - www.642weather.com/weather/contact_us.php
Donate:          https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=2319642

Support thread at weather-watch forum:
http://www.weather-watch.com/smf/index.php/topic,40862.0.html

*/
$Version = 'Version: 2.02 - 16-Jun-2013';
/*

You are free to use and modify the code

This php code provided "as is", and Long Beach Weather (Michael Challis)
disclaims any and all warranties, whether express or implied, including
(without limitation) any implied warranties of merchantability or
fitness for a particular purpose.

See included readme.txt for instructions on how to schedule automatic timed message sending  

*/

// testtags file
// relative path can be changed as needed
//$data_file = '../testtags.php';
$data_file = 'testtags.php';

// set units of measures indicators:
// not this does NOT make any conversions!
//$uomTemp = 'F';
$uomTemp = 'F';
$uomWind = 'mph';
$uomBaro = 'in';
$uomRain = 'in';

// This setting changes how wind is displayed
// set to 1 for: Wind ENE 3->14mph
// set to 0 for: Wind ENE 3mph, MaxGust 14mph
$short_wind_option = 0;

// security feature: require post authentication to send messages
// (my favorite method because I can set my cron for every 1 hour)
// this feature is great because then you can put the script in a public view
// requires cron command line input with curl like in this example (be sure to set your_username and your_password):
// curl -d 'username=your_username&password=your_password' http://www.642weather/weather/wd-conditions-messenger.php >/dev/null 2>&1
$require_post = 1; // set to 1 to enable

// security feature: username
// used when $require_post = 1;
$post_username = '';

// security feature: password
// used when $require_post = 1;
$post_password = '';

// email address to receive the messages
// Yes you can send to multiple emails, both methods are acceptable
// $email_address = 'user@example.com, anotheruser@example.com';
$email_address = 'you@yoursite.com';

// email address(s) to receive Bcc (Blind Carbon Copy) messages
// Yes you can send to multiple emails, both methods are acceptable
// $email_address_bcc = 'user@example.com';
// $email_address_bcc = 'user@example.com, anotheruser@example.com';
$email_address_bcc = ''; //

// email address alerts are sent from
$email_address_sent_from = 'you@yoursite.com';

// Customize your email subject
$email_subject = 'Weather';  // keep short if you are emailing your phone!

// Customize your email alert message, but do not remove the <conditions> tag!!
// The <conditions> tag is automatically replaced with the weather conditions information.
// You can add or remove words before or after the <conditions> tag
$email_message = 'Long Beach, WA: <conditions>'; // keep short if you are emailing your phone!

// set to 1 when testing the script (will not send ANY emails!, be sure to set it back when done testing)
// set to 0 for normal operation
$do_not_email = 1;

// Prevent message flooding (during the flood timer, script will not send ANY emails or tweets!)
// ignored when using post authentication $require_post = 1; (post authentication is the best way)
// this prevents yahoos from clicking on your URL repeatedly and causing it to email and tweet each click
// set to 0 when testing the script
// set to 1 to enable for normal operation
$flood_filter_enabled = 0; // not needed to be enabled if you have $require_post enabled

// Set flood filter minutes slightly less than the time interval you want messages sent
// ie: if you want messages every 1 hour, set the flood filter for 55 minutes
// My cron actually calls this script every 15 minutes, but I set the $flood_filter_minutes to 55 minutes.
// This allows the script to send a message approx every 1 hour.
// I actually control the interval with this setting, even though cron calls this script every 15 minutes
$flood_filter_minutes = 55; // 55 minutes   ignored if you have $require_post enabled

// Name of file used to prevent message flooding
// the script sets this file when a message is sent
// if the file is present, the script checks the timestamp of the file determine when the last message was sent
// if the file time is too recent, the script will NOT send any messages
$flood_filter_file = 'wd-conditions-messenger-flood.txt';

// Sending the message to twitter is optional
// set to 1 to enable sending the message to twitter
// set to 0 to disable twitter
$twitter_enabled = 0;

// Relative path to TweetWX twitter authentication library directory
// required only if twitter is enabled
$tweetWXdir = './TweetWX/'; // end with slash

// Customize your twitter message, but do not remove the <conditions> tag!!
// The <conditions> tag is automatically replaced with the actual conditions message.
// You can add or remove a hash tag. Keep as short as possible.
$twitter_message = 'Long Beach, WA: <conditions> #weather';

// number of characters to attempt to shorten twitter message to
$twitter_shorten = '140';

// number of characters to attempt to shorten email message to
$email_shorten = '120';

// array of words to shorten when the message is more than the desired characters.
// array is formatted is like this: 'Long Word' => 'Short Word',
// you can add or comment out lines from this array as you like
// the shorten_message function will loop through the word replacements one at a time and break early
// if the message is shortened enough.
$shorten_words_array = array(
'Showers'     => 'Shwrs',
'Rain'        => 'Rn',
'Chance'      => 'Chce',
'Partly'      => 'Ptly',
'Cloudy'      => 'Cldy',
'Forecast'    => 'Frcst',
'Night Time/' => '',
'Night time/' => '',
'Cloudy with clear patches' => 'Ptly Cldy',
'mostly cloudy -'  => 'Cldy',
'Temp'        => 'Tmp',
'Wind'        => 'Wnd',
'MaxGust'     => 'Gust',
'Baro'        => 'Bar',

);

//------------------------------------------------------------------
// end settings. Do not alter any code below this point in the script or it may not run properly.
//------------------------------------------------------------------

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<title>Weather Display Conditions Messenger PHP Script by Mike Challis</title>
</head>
<body>
';

if (phpversion() < 5) {
  echo 'Failure: This Script requires PHP version 5 or greater. You only have PHP version: ' . phpversion();
  exit;
}

// initialize vars
global $Status;
$Summary = '';
$string = '';
$Status = '';
$flood_blocked = 0;

$Status = "<!-- $Version -->\n";

include_once($data_file);

$sTemp = round(strip_units($temperature),0);;
$sHum  = $humidity;

if ($short_wind_option) { // ken tue's method
  $sWind = "$dirlabel " . round($avgspd,0)."->".round(strip_units($maxgst),0).$uomWind;
  if (preg_match('|0->0|',$sWind) ){
	$sWind = 'Calm';
  }
} else {  // my method
   $sWindAvg = round($avgspd,0);
   if ($sWindAvg > 0) {
           $sWindAvg = "$dirlabel $sWindAvg$uomWind";
   } else {
           $sWindAvg = 'Calm';
   }
   $sGust = round(strip_units($maxgst),0);
   $sWind = "$sWindAvg, MaxGust $sGust$uomWind";
}
$sBaro = sprintf("%01.2f",round(strip_units($baro),2));
$sRain = sprintf("%01.2f",strip_units($dayrn));
$sHL = '(H'.round(strip_units($maxtemp),0).'/L'.round(strip_units($mintemp),0).')'; // (H84/L59)

// uncomment only one of these two condition tags
$sCond = trim($Currentsolardescription); // current condition: Night Time/Dry/Cloudy
//$sCond = trim($weathercond);           // current condition: Dry

$wxconditions = fixup_time($time)." $sCond, Temp $sTemp$uomTemp$sHL, Wind $sWind, Baro $sBaro$uomBaro, RainToday $sRain$uomRain, Hum $sHum%";

if ($temperature == '') {
     echo "${string}${Status}Weather Conditions Unavailable, error fetching or reading data from the testtags.php file.</a>\n";
     exit;
}


// message flood blocking feature
if ($flood_filter_enabled and file_exists($flood_filter_file) and filemtime($flood_filter_file) + ($flood_filter_minutes * 60) > time()) {
  $flood_blocked = 1;
  $flood_time = time_offline( ( ( filemtime($flood_filter_file) + ($flood_filter_minutes * 60) ) - time() )  );
}


echo "${Status}
<h3>Weather Display Conditions Messenger PHP Script by Mike Challis</h3>\n";

echo "<strong>Current Weather Conditions:</strong> $noaacityname $dayname $date $time<br />$wxconditions<br /><br />";


echo '<strong>Message Sending Activity:</strong><br /><br />';

echo '<strong>Email:</strong> ';

     // email the messaage
     $email_headers = "From: " . $email_address_sent_from ."\n";
     if ($email_address_bcc !='') $email_headers .= "Bcc: " . $email_address_bcc ."\n";
     $email_message = str_replace('<conditions>',"$wxconditions",$email_message);
     if (strlen($email_message) > $email_shorten ) {
        // email message is too long, attempt to shorten it.
        $email_message = shorten_message($email_message,$email_shorten);
     }
     $email_message = $email_message . "\n";

     if ($require_post) {
           $passed_login = 0;
           if ( pass_login() == true ) {
                 $passed_login = 1;
                 echo '(Login passed, ';
                 if(!$do_not_email) {
                     // send the message
                    mail($email_address, $email_subject, $email_message, $email_headers);
                    // show the email on the web page
                    echo 'An email was sent:<br />';
                 }
           }
            // did not pass login, message not sent
            echo '(Login failed, no email was sent)<br/>';
     } else {
      // send the message
            if(!$do_not_email && !$flood_blocked) {
              mail($email_address, $email_subject, $email_message, $email_headers);
              echo 'An email was sent:<br />';
              if ($flood_filter_enabled) {
                  file_put_contents($flood_filter_file, time());
              }
            }
     }

     // fresh advisory
     if($do_not_email) { // test setting enabled: $do_not_email = 1;
             echo '(Email sending is disabled in settings, no email was sent)<br />';
     } else if($flood_blocked) {
             echo "(Flood filter is in effect for $flood_time, no email was sent)<br />";
     }
     echo "Subject: $email_subject<br />";
     echo "Message: $email_message<br />";
     echo 'Email message length: '.strlen($email_message);

     echo '<br /><br />';
     echo '<strong>Twitter:</strong> ';

     $twitter_message = str_replace('<conditions>',"$wxconditions",$twitter_message);

     if (strlen($twitter_message) > $twitter_shorten ) {
        // twitter message is too long, attempt to shorten it.
        $twitter_message = shorten_message($twitter_message,$twitter_shorten);
     }

     if ($twitter_enabled)
         require_once($tweetWXdir . 'TweetWX-globals.php');

     if ($twitter_enabled && $require_post) {
           if ( $passed_login ) {
              // send the Twitter now
              twitter_alert($twitter_message);

           } else {
             echo "(Login failed, no twitter was sent)<br />";
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
           }
            // did not pass login, twitter message not sent
     } else if ($twitter_enabled && !$flood_blocked){
              // send the Twitter now
              twitter_alert($twitter_message);

              if ($flood_filter_enabled) {
                 file_put_contents($flood_filter_file, time());
              }
     } else if($twitter_enabled && $flood_blocked) {
             echo "(Flood filter is in effect for $flood_time, no twitter was sent)<br />";
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
     }

     if(!$twitter_enabled) {
             echo '(Twitter sending is disabled in settings, no twitter sent)<br />';
             echo $twitter_message.'<br />';
             echo 'Twitter message length: '.strlen($twitter_message).'<br />';
     }


echo '<p>Done!</p>
<p>PHP Scripts by Mike Challis<br />
<a href="http://www.642weather.com/weather/scripts.php">Free PHP Scripts</a><br />
<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&amp;hosted_button_id=2319642">Donate</a>, even small amounts are appreciated
</p>';

echo '
  </body>
</html>
';


// ---------------------------- functions -----------------------------------

function shorten_message($message,$chars_length) {

     global $shorten_words_array;  // array of long/short word replacements from settings

     // message is too long, attempt to shorten it.
     // loop through array of long/short word replacements from settings
     foreach ($shorten_words_array as $long_word => $short_word) {
        if (strlen($message) > $chars_length ) {
                $message = str_replace("$long_word","$short_word",$message);
        } else {
                break; // shortened enough already, break out of the loop
        }
     }

     return $message;

} // end function shorten_message
// ------------------------------------------------------------------

function twitter_alert($twitter_message) {
 global $access_token, $access_token_secret;

   $utfmessage = iconv('ISO-8859-1','UTF-8',$twitter_message);

   // POST a tweet using OAuth authentication
   $retarr = post_tweet(OAUTH_CONSUMER_KEY, OAUTH_CONSUMER_SECRET,
              $utfmessage, $access_token, $access_token_secret,true, true);

   echo '<br />';

  // check for success or failure for twitter message sending
  if (empty($retarr)) {
          echo 'WARNING: Twitter message not sent (check twitter settings)<br />';
  } else {
          echo 'A Twitter was sent:<br />';
          echo $twitter_message.'<br />';
          echo 'Twitter message length: '.strlen($twitter_message).'<br />';
  }

} // end function twitter_alert
// ------------------------------------------------------------------

function time_offline ($time) {
    // takes a time diff like 6740 secs and formats to '1 hour, 52 minutes'
    $hrs  = (int) intval($time / 3600);
    $time = (int) intval($time - (3600 * $hrs));
    $mns  = (int) intval($time / 60);
    $time = (int) intval($time - (60 * $mns));
    $secs = (int) intval($time / 1);
    $hrs == 1 and $string .= "$hrs hour, ";
    $hrs > 1 and $string .= "$hrs hours, ";
    $string .= sprintf("%01d minutes", $mns);
    return $string;

} // end function time_offline
// ------------------------------------------------------------------


// change the hh:mm AM/PM to h:mmam/pm format
function fixup_time ( $WDtime ) {
  if ($WDtime == "00:00: AM") { return ''; }
  $WDtime = preg_replace('|^0:|','12:',$WDtime);
  return date('g:ia' , strtotime($WDtime));
}

// strip trailing units from a measurement
// i.e. '30.01 in. Hg' becomes '30.01'
function strip_units ($data) {
  preg_match('/([\d\.\+\-]+)/',$data,$t);
  return $t[1];
}

function pass_login() {
    global $post_username, $post_password;
  // authenticate login
  // user provided password
  if (isset($_POST['username']) && isset($_POST['password']) && $post_username != '' && $post_password != '') {
    if ( ($_POST['username'] == $post_username) && ($_POST['password'] == $post_password) ) {
            return true;
    } else {
            // user or pass incorrect
            return false;
    }
  }
  // user or pass not posted
  return false;
} // end function pass_login
// ------------------------------------------------------------------
?>